#include "gungame.h"
#include <algorithm>
#include <iostream>
#include <map>
#include <vector>
using namespace std;

map<pair<int, int>, int> edges;
int ask_count = 0;

int ask(vector<int> S, int w) {
  ++ask_count;
  sort(S.begin(), S.end());
  for (int i = 0; i < (int)S.size(); i++) {
    for (int j = i + 1; j < (int)S.size(); j++) {
      auto it = edges.find(make_pair(S[i], S[j]));
      if (it != edges.end() && it->second <= w) {
        return 1;
      }
    }
  }
  return 0;
}

int main() {
  cin.tie(0)->sync_with_stdio(0);
  int n, m;
  cin >> n >> m;
  while (m--) {
    int u, v, w;
    cin >> u >> v >> w;
    if (u > v) swap(u, v);
    auto it = edges.find(make_pair(u, v));
    if (it != edges.end()) {
      it->second = min(it->second, w);
    } else {
      edges[make_pair(u, v)] = w;
    }
  }
  cout << "play(n) returns " << play(n) << '\n';
  cout << "d = " << ask_count << '\n';
  return 0;
}
